#include "uogetopt.h"
#include "_stralloc.h"
#include "_error.h"
#include "_str.h"
#include "_ip4.h"
#include "_buffer.h"
#include "_scan.h"
#include "_readwrite.h"
#include "fmt.h"
#include "getln.h"
#include "bailout.h"
#include "interface.h"
static stralloc sa=STRALLOC_INIT;
static void die_format(void) { bailout(0,"bad input data: ",sa.s,0,0); }

void 
readloop(int fd)
{
	buffer inbuf;
	char bufspace[BUFFER_INSIZE];

	buffer_init(&inbuf,read,fd,bufspace,sizeof(bufspace));

	while (1) {
		int gotlf;
		unsigned int l;
		unsigned int i;
		char ipto[4];
		char ipfrom[4];
		unsigned long packets;
		unsigned long bytes;
		if (-1==getln(&inbuf,&sa,&gotlf,'\n'))
			bailout(errno,"failed to read input data",0,0,0);
		if (sa.len==0) break;
		if (!gotlf)
			bailout(0,"incomplete last line in input data",0,0,0);
		sa.s[--sa.len]=0; 
		if (sa.len && sa.s[sa.len-1]=='\r')
			sa.s[--sa.len]=0; 
		if (str_start(sa.s,"Date: "))
			continue;
		if (str_start(sa.s,"Accounting data age is "))
			continue;
		if (!sa.len) continue;
		/* skip spaces */
		for (i=0;i<sa.len;i++)
			if (sa.s[i]!=' ')
				break;
		if (i==sa.len) die_format();
		if (str_start(sa.s+i,"Source ")) continue;

		/* get IP from */
		l=ip4_scan(sa.s+i,ipfrom);
		if (l==0) die_format();
		i+=l;
		/* skip spaces */
		if (sa.s[i]!=' ')  die_format();
		for (;i<sa.len;i++)
			if (sa.s[i]!=' ')
				break;
		if (i==sa.len) die_format();
		/* get IP to */
		l=ip4_scan(sa.s+i,ipto);
		if (l==0) die_format();
		i+=l;
		/* skip spaces */
		if (sa.s[i]!=' ')  die_format();
		for (;i<sa.len;i++)
			if (sa.s[i]!=' ')
				break;
		if (i==sa.len) die_format();
		/* get packet count */
		l=scan_ulong(sa.s+i,&packets);
		if (l==0) die_format();
		i+=l;
		/* skip spaces */
		if (sa.s[i]!=' ')  die_format();
		for (;i<sa.len;i++)
			if (sa.s[i]!=' ')
				break;
		if (i==sa.len) die_format();
		/* get byte count */
		l=scan_ulong(sa.s+i,&bytes);
		if (l==0) die_format();
		i+=l;
		if (sa.s[i]!=' ' && sa.s[i]!='\0')  die_format();
		accorecord(ipfrom,ipto,packets,bytes);
	}
}

